/********************************************************************************
 *	window.h
 *
 *	Window Management Header
 *
 *	Written by Paco Xander Nathan
 *	1990, Motorola Inc.  Public domain source code.
 ********************************************************************************/

#define _H_window

#include <TextEdit.h>
#include <ListMgr.h>


typedef enum {
	widText = 128, widTest, widGnos
} WindRsrcID;


typedef enum {
	windBug = 1, windDis, windBus, windSpace1,
	windLog, windSig, windReg, windMem, windSym, windSpace2,
	windBringFront, windCleanUp, windCloseAll
} WindMenuItems;


typedef enum {
	tileFill = 1, tileStack, tileVert, tileHorz
} WindTileMenuItems;


typedef enum {
	wkNone, wkText, wkList, wkDlog
} WindKind;


typedef struct {
	TEHandle teHdl;
	ControlHandle scroll;
} TextInfo;


typedef struct {
	Str255 fileName;
	short vRefNum;
	Rect offset;
	WindKind kind;
	Boolean active;
	Boolean dirty;
	Boolean named;
	union {
		TextInfo text;
		ListHandle list;
		DialogPtr dlog;
	} item;
} InfoRecord, *InfoPtr;


/* External Data Structures
 */
extern WindowPtr
	wPtrText, 
	wPtrTest,
	wPtrGnos;

extern Rect 
	dragArea,
	growArea;

extern Boolean
	windTrip;


/* External Function Prototypes
 */
#ifdef PROTOTYPES
Boolean WindIsDlog (WindowPtr theWindow);
Boolean WindIsApp (WindowPtr theWindow);
Boolean WindIsDA (WindowPtr theWindow);
void WindPlace (WindowPtr, short, short, short, short);
void WindTileStack (void);
void WindCenter (WindowPtr theWindow);
void WindReDraw (WindowPtr theWindow);
void WindZoom (WindowPtr theWindow, short thePart);
void WindGrow (WindowPtr theWindow, EventRecord *theEvent);
void WindUpdate (WindowPtr theWindow);
void WindActivate (WindowPtr theWindow, Boolean isActive);
void WindAdjust (WindowPtr theWindow);
void WindContent (WindowPtr theWindow, EventRecord *theEvent);
void WindSwitch (WindowPtr theWindow, Boolean pleaseOpen);
WindowPtr WindAllocate (short windID, Boolean isActive);
void WindClose (WindowPtr theWindow);
void WindZapPort (WindowPtr wind, Boolean up);
#endif